
#include <ocl/Component.hpp>
#include <rtt/TaskContext.hpp>

#include <vector>

using namespace RTT;
using namespace OCL;

class TestCase : public RTT::TaskContext {

	public:
	
	TestCase(const std::string& name, TaskState initial_state = PreOperational) : TaskContext(name, initial_state) {		
		this->properties()->addProperty("vecbools1", vecbools_prop1);	
		this->properties()->addProperty("vecbools2", vecbools_prop2);
		this->properties()->addProperty("bool1", bool_prop1);
		this->properties()->addProperty("bool2", bool_prop2);
	}
	
	~TestCase() {
	}

private:	
	std::vector<bool> vecbools_prop1, vecbools_prop2;
	bool bool_prop1, bool_prop2;
	
	bool configureHook() {
		std::cout << "------------- size of vecbools1: " << vecbools_prop1.size() << std::endl;
		std::cout << "------------- bool1: " << (bool_prop1 ? "true" : "false") << std::endl;
		std::cout << "------------- bool2: " << (bool_prop2 ? "true" : "false") << std::endl;
		
		vecbools_prop2.resize(4,true);
		std::cout << "------------- resized vecbools2: " << vecbools_prop2.size() << std::endl;
		return true;
	}
	bool startHook() {
		return true;
	}
	
	void updateHook() {}
	void stopHook() {}
	void cleanupHook() {}
};


ORO_CREATE_COMPONENT( TestCase);
